version: '3.7'

networks:
  public_network:
    external: true
  internal_network:
    external: false

services:
  reverse-proxy:
    image: traefik
    container_name: reverse-proxy
    # Uncomment --api.insecure option and port mapping below for API & dashboard.
    command:
      - --providers.docker=true
#      - --api.insecure=true
#      - --accesslog=true
#      - --log=true
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
    networks:
      - internal_network
      - public_network
    ports:
      - "80:80"
      ## Uncomment below for dashboard.
#      - "8095:8080"

  mongo-db:
    image: mongo:3.4.9
    container_name: "mongo-db"
    volumes:
      - ${PROV_TMPL_DATABASE}:/data/db
    ports:
      - 27017
    networks:
      - internal_network
    user: mongodb
    command: mongod --dbpath /data/db # --quiet
    environment:
      - PROV_TMPL_DATABASE

  prov-template-api:
    build:
      context: .
      dockerfile: Dockerfile.api
    container_name: "prov-template-api"
    image: prov-template-svc:latest
    ports:
      - 5000
    networks:
      - internal_network
    links:
      - mongo-db
    depends_on:
      - mongo-db
      - reverse-proxy
    environment:
      - PROV_TMPL_MONGODB_HOSTPORT=mongo-db:27017
      - PROV_TMPL_github_KEY
      - PROV_TMPL_github_SECRET
      - PROV_TMPL_JWT_SECRET
    labels:
      ## We are relying on traefik's ordering by rule length here. Since this
      ## rule is longer than provtemplateweb's rule, this one will be evaluated first.
      - "traefik.http.routers.provtemplateapi.rule=Host(`localhost`) && (PathPrefix(`/prov-template-catalog/api/`) || PathPrefix(`/prov-template-catalog/api/login`))"

  prov-template-web:
    build:
      context: .
      dockerfile: Dockerfile.web
    container_name: "prov-template-web"
    image: prov-template-web:latest
    ports:
      - 80
    networks:
      - internal_network
    depends_on:
      - prov-template-api
      - reverse-proxy
    labels:
      - "traefik.http.routers.provtemplateweb.rule=Host(`localhost`) && PathPrefix(`/prov-template-catalog`)"
